#include "includes.h"
#include "fill_file.h"
#include "increasing.h"
#include "output.h"
#include <sstream>

using namespace std;

namespace fill_file{

	void fill_flat(string s, vector<int> &v){
		stringstream ss;
		ss<<"input/"<<s<<".txt";
		string fn=ss.str();
		ifstream f(fn.c_str());
		if(f.fail()){
			cout<<"File not found! \""<<fn<<"\"\n\n";
			//exit(1);
			v.push_back(1);
		}else{
			cout<<"\""<<fn<<"\" loaded.\n";

			int i=0;
			string tmp;
			v.resize(0);
			while(!f.eof()){
				f>>tmp;
				if(tmp!=""){
					v.push_back(1);
					v[i]=atoi(tmp.c_str());
					i++;
				}
			}

			bool result=increasing(v);
			output(result,v);
		}
	}

	void fill_formatted(string s, vector<int> &v){
		stringstream ss;
		ss<<"input/"<<s<<".txt";
		string fn=ss.str();
		ifstream f(fn.c_str());
		if(f.fail()){
			cout<<"File not found! \""<<fn<<"\"\n\n";
			//exit(1);
			v.push_back(1);
		}else{
			cout<<"\""<<fn<<"\" loaded.\n";

			int n;f>>n;
			v.resize(n);
			string tmp;
			for(int i=0;i<n;i++){
				f>>tmp;
				v[i]=atoi(tmp.c_str());
			}

			bool result=increasing(v);
			output(result,v);
		}
	}

}
