#include "includes.h"
#include "read.h"
using namespace std;

bool nat(int n){return n>=0;}//natural

int read_int(const string &msg, const string &err, bool check(int)){
	int n;
	bool loop=false;
	string devnull;
	do{
		cout<<msg;
		cin>>n;
		loop=cin.fail() || !check(n);
		if(loop){
			cout<<err<<endl;
			cin.clear();
			getline(cin, devnull);
		}
	}while(loop);
	return n;
}

string read_str(const string &msg, const string &err, bool check(string)){
	string s;
	bool loop=false;
	string devnull;
	do{
		cout<<msg;
		cin>>s;
		loop=cin.fail() || !check(s);
		if(loop){
			cout<<err<<endl;
			cin.clear();
			getline(cin, devnull);
		}
	}while(loop);
	return s;
}

double read_elem(int i, const std::string &err, bool check(int)){
	int r;
	bool loop=false;
	string devnull;
	do{
		cout<<"The "<<i+1;
		if((i+1)%10==1){
			cout<<"st";
		}else if((i+1)%10==2){
			cout<<"nd";
		}else if((i+1)%10==3){
			cout<<"rd";
		}else{
			cout<<"th";
		}
		cout<<" element: ";
		cin>>r;
		loop=cin.fail() || !check(r);
		if(loop){
			cout<<err<<endl;
			cin.clear();
			getline(cin, devnull);
		}
	}while(loop);
	cin.clear();
	getline(cin, devnull);
	return r;
}
